/*******************************************************************************
 * Copyright (c) 2014 BREDEX GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     BREDEX GmbH - initial API and implementation and/or initial documentation
 *******************************************************************************/
package org.eclipse.jubula.toolkit.gef;

import javax.annotation.Generated;

import org.apache.commons.lang.Validate;
import org.eclipse.jdt.annotation.NonNull;
import org.eclipse.jubula.tools.ComponentIdentifier;
import org.eclipse.jubula.toolkit.annotations.Beta;
import org.eclipse.jubula.toolkit.ToolkitInfo;
import org.eclipse.jubula.toolkit.gef.internal.GefToolkitInfo;

/**
 * Factory for creating components from the gef toolkit.
 * @noextend This class is not intended to be extended by clients.
 */
@Generated(value = "org.eclipse.jubula.toolkit.api.gen.FactoryGenerator", 
           date =  "2019-11-26T06:47:22.844Z")
public class GefComponents {
    
    @NonNull private final static ToolkitInfo TOOLKIT_INFORMATION = GefToolkit.createToolkitInformation();

    private GefComponents() {
        super();
    }
    
    /** 
     *  @return the toolkit information, not recommended to be modified
     */
    @NonNull public static ToolkitInfo getToolkitInformation() {
        return TOOLKIT_INFORMATION;
    }

    /** create a new representative for a {@link org.eclipse.draw2d.FigureCanvas} UI component.
     * 
     */
    @NonNull public static org.eclipse.jubula.toolkit.gef.components.FigureCanvas createFigureCanvas (@NonNull ComponentIdentifier<? extends org.eclipse.jubula.toolkit.gef.components.FigureCanvas> componentIdentifier) {
        Validate.notNull(componentIdentifier);
        return new org.eclipse.jubula.toolkit.gef.internal.impl.FigureCanvas(componentIdentifier);
    }
    
    /** create a new representative for a {@link org.eclipse.draw2d.FigureCanvas} UI component.
     * @since 4.0
     */
    @NonNull public static org.eclipse.jubula.toolkit.gef.components.handler.FigureCanvasActionHandler createFigureCanvasActionHandler (@NonNull ComponentIdentifier<? extends org.eclipse.jubula.toolkit.gef.components.FigureCanvas> componentIdentifier) {
        Validate.notNull(componentIdentifier);
        return new org.eclipse.jubula.toolkit.gef.internal.impl.handler.FigureCanvasActionHandler(componentIdentifier);
    }
}